function [costs, ws, omegas] = SGD(data, labels, w, omega, pairing, gamma, maxIter, eta)
    costs = zeros(maxIter+1, 1);
    costs(1) = costfunction(data, labels, [w;omega], pairing, gamma);
    ws = zeros(maxIter+1, size(w, 1), size(w, 2));
    ws(1, :, :) = w;
    
    omegas = zeros(maxIter+1, size(omega, 1), size(omega, 2));
    omegas(1, :, :) = omega;

    [dim1 dim] = size(omega);
    nrProt = size(w, 1);
    
    for iter=1:maxIter
        for i = 1:size(data,1) 
            grad= gradient(data(i,:), labels(i), w, omega, pairing(i, :), gamma);
            
            w = w - eta(iter, 1) * grad(1:nrProt, :);
            omega = omega  - eta(iter, 2) * grad(nrProt+1:end, :);
        end
        [costs(iter + 1), ~] = costfunction(data, labels, [w;omega], pairing, gamma);
        omegas(iter+1, :, :) = omega;
        ws(iter+1, :, :) = w;
    end
end

