function hess = finitediffHessian(data, labels, w, w_labels, omega, gamma)
    [dim1 dim] = size(omega);
    hess = zeros(numel(w) + numel(omega), numel(w) + numel(omega));
    err = 1e-4; %Small perturbation
    [~, g] = gradient(data, labels, w, w_labels, omega, gamma);
    
    for i = 1:size(w, 1)
        for j=1:size(w, 2)
            w2 = w;
            w2(i, j) = w2(i, j) + err;
            [~, g2] = gradient(data, labels, w2, w_labels, omega, gamma);
            hess((i-1)*dim +j, :) = reshape(((g2 - g)./err)', 1, numel(w) + numel(omega));
        end
    end
    
    k = numel(w);
    
    for i=1:size(omega, 1)
        for j=1:size(omega, 2)
            omega2 = omega;
            omega2(i, j) = omega2(i, j) + err;
            [~, g2] = gradient(data, labels, w, w_labels, omega2, gamma);
            hess(k + (i-1)*dim +j, :) = reshape(((g2 - g)./err)', 1, numel(w) + numel(omega));
        end
    end
    
    %Symmetrize
    hess = (hess' + hess)/2;
end